
import 'dart:async';
import 'dart:convert';
import 'package:fawry_sdk/model/fawry_launch_model.dart';
import 'package:flutter/services.dart';
import 'fawry_sdk_platform_interface.dart';

class MethodChannelFlutterFawryPay extends FawrySdkPlatformInterface {
  static const String _CHANNEL_NAME = "channel/fawry_sdk";

  static const String _METHOD_INIT = "init";

  static const String _ERROR_INIT = "1";

  static const MethodChannel _channel = MethodChannel(_CHANNEL_NAME);

  @override
  Future<bool> init({
    required FawryLaunchModel launchModel,
    required String baseURL,
    required String lang,
  }) async {
    try {
      return await _channel.invokeMethod(_METHOD_INIT, <String, String>{
        'launchModelJson': json.encode(launchModel),
        'baseURL' : baseURL,
        'lang' : lang
      });
    } on PlatformException catch (e) {
      if (e.code == _ERROR_INIT) {
        throw "Error Occurred: Code: $_ERROR_INIT. Message: ${e.message}. Details: SDK Init Error";
      }
      throw "Error Occurred: Code: ${e.code}. Message: ${e.message}. Details: ${e.details}";
    } catch (e) {
      throw "Error Occurred: Message: $e";
    }
  }
}
