
import 'dart:async';
import 'package:fawry_sdk/model/fawry_launch_model.dart';
import 'package:plugin_platform_interface/plugin_platform_interface.dart';
import 'fawry_sdk_method_channel.dart';

abstract class FawrySdkPlatformInterface extends PlatformInterface {

  FawrySdkPlatformInterface() : super(token: _token);

  static final Object _token = Object();

  static FawrySdkPlatformInterface _instance = MethodChannelFlutterFawryPay();

  static FawrySdkPlatformInterface get instance => _instance;

  static set instance(FawrySdkPlatformInterface instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  Future<bool> init({
    required FawryLaunchModel launchModel,
    required String baseURL,
    required String lang
  }) {
    throw UnimplementedError('init() has not been implemented.');
  }
}
