import 'package:fawry_sdk/model/payment_methods.dart';

import 'bill_item.dart';
import 'launch_customer_model.dart';
import 'launch_merchant_model.dart';

class FawryLaunchModel {
   bool allow3DPayment;
   List<BillItem> chargeItems;
   LaunchCustomerModel? launchCustomerModel;
   LaunchMerchantModel launchMerchantModel;
   bool skipLogin;
   bool skipReceipt;

  FawryLaunchModel(
      {required this.allow3DPayment,
      required this.chargeItems,
      this.launchCustomerModel,
      required this.launchMerchantModel,
      required this.skipLogin,
      required this.skipReceipt});

  Map<String, dynamic> toJson() {
    List<Map>? chargeItems = this.chargeItems.map((i) => i.toJson()).toList();
    Map? launchCustomerModel = this.launchCustomerModel?.toJson();
    Map? launchMerchantModel = this.launchMerchantModel.toJson();

    return {
      'allow3DPayment': allow3DPayment,
      'chargeItems': chargeItems,
      'launchCustomerModel': launchCustomerModel,
      'launchMerchantModel': launchMerchantModel,
      'skipLogin': skipLogin,
      'skipReceipt': skipReceipt,
      'merchant': launchMerchantModel,
      'customer': launchCustomerModel,
      'skipCustomerInput': skipLogin
    };
  }
}
